<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: convertToTargetUnitSystem.xsl,v 1.2 2009/10/20 20:40:10 phaeton Exp $ -->
<!-- By the way, I've TRIED using a 1.0 version stylesheet. Just the existing browsers won't cope anyways. -->
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:unitsml="urn:oasis:names:tc:unitsml:schema:xsd:UnitsMLSchema-0.9.18" 
  xmlns:uscd="http://ayaken.net/2008/USCD/1"
  xmlns:nvc="http://ayaken.net/2008/NVC/1">
  <xsl:output method="xml" media-type="text/xml" encoding="UTF-8" omit-xml-declaration="no" version="1.0" indent="yes"/>
  <xsl:strip-space elements=""/>
  <xsl:preserve-space elements="*"/>
  <!-- The following variable needs a binding from the calling environment. -->
  <!-- It contains the (numerical) ID of the target Unit we want to convert to. -->
  <xsl:param name="USCDFile" select="'USCD.xml'" />
  <!-- 
  <xsl:import-schema 
    namespace="urn:oasis:names:tc:unitsml:schema:xsd:UnitsMLSchema-0.9.18" 
    schema-location="UnitsML.xsd" />
  <xsl:import-schema 
    namespace="http://ayaken.net/2008/NVC/1" 
    schema-location="NVUnitsMLSchema.xsd" />
  <xsl:import-schema 
    namespace="http://ayaken.net/2008/USCD/1"
    schema-location="UnitsML-USCD.xsd" />
  -->
  <xsl:variable name="USCD">
    <xsl:copy-of select="document($USCDFile)" />
  </xsl:variable>
  <xsl:param name="targetUnitSystem">
    <xsl:value-of select="normalize-space($USCD//uscd:target/text())" />
  </xsl:param>
  <xsl:variable name="unitInfo">
    <!-- 'forward' conversions -->
    <!-- <xsl:copy-of select="//unitsml:Unit/unitsml:UnitSystem[
      @name=$targetUnitSystem]/.. |
      //unitsml:Unit/unitsml:Conversions/unitsml:Float64ConversionFrom[ 
      id(substring-after(@initialUnit, '#'))/unitsml:UnitSystem/@name = $targetUnitSystem
      ]/../.."
      /> -->
    <!-- 'backwards' (inverse) conversions -->
    <xsl:for-each select="//unitsml:Unit" >     <!-- for all units -->
      <unitsml:Unit xml:id="{@xml:id}">
        <unitsml:UnitSystem name="{./unitsml:UnitSystem/@name}" type="{./unitsml:UnitSystem/@type}" />
        <unitsml:Conversions>
			<!-- <xsl:copy-of select=".//unitsml:Conversions/unitsml:Float64ConversionFrom" /> -->
          <xsl:variable name="current-unit-id" select="current()/@xml:id" />
		  <xsl:variable name="current-conversions" select=".//unitsml:Conversions/unitsml:Float64ConversionFrom/@initialUnit" />
		  <xsl:for-each select=".//unitsml:Conversions/unitsml:Float64ConversionFrom">
				<xsl:variable name="divisor">
					<xsl:choose><xsl:when test="string-length(normalize-space(@divisor)) = 0"><xsl:value-of select="'1'" /></xsl:when><xsl:otherwise><xsl:value-of select="@divisor"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="multiplicand">
					<xsl:choose><xsl:when test="string-length(normalize-space(@multiplicand)) = 0"><xsl:value-of select="'1'" /></xsl:when><xsl:otherwise><xsl:value-of select="@multiplicand"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="finalAddend">
					<xsl:choose><xsl:when test="string-length(normalize-space(@finalAddend)) = 0"><xsl:value-of select="'0'" /></xsl:when><xsl:otherwise><xsl:value-of select="@finalAddend"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="initialAddend">
					<xsl:choose><xsl:when test="string-length(normalize-space(@initialAddend)) = 0"><xsl:value-of select="'0'" /></xsl:when><xsl:otherwise><xsl:value-of select="@initialAddend"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="exact">
					<xsl:choose><xsl:when test="string-length(normalize-space(@exact)) = 0"><xsl:value-of select="'false'" /></xsl:when><xsl:otherwise><xsl:value-of select="@exact"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
              <unitsml:Float64ConversionFrom 
                initialUnit="{@initialUnit}" exact="{$exact}"
                multiplicand="{$multiplicand}"
                divisor="{$divisor}"
                initialAddend="{$initialAddend}"
                finalAddend="{$finalAddend}"/>
			</xsl:for-each>
          <xsl:for-each select="//unitsml:Unit[.//unitsml:Float64ConversionFrom[
            substring-after(@initialUnit, '#') = $current-unit-id]]" >   <!-- for all conversions starting from here -->
            <!-- construct inverse conversion, looking same as usual -->
            <xsl:variable name="initial-unit-id" select="@xml:id" />
            <xsl:for-each select=".//unitsml:Float64ConversionFrom[
              substring-after(@initialUnit, '#') = $current-unit-id]" >
				<xsl:variable name="divisor">
					<xsl:choose><xsl:when test="string-length(normalize-space(@divisor)) = 0"><xsl:value-of select="'1'" /></xsl:when><xsl:otherwise><xsl:value-of select="@divisor"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="multiplicand">
					<xsl:choose><xsl:when test="string-length(normalize-space(@multiplicand)) = 0"><xsl:value-of select="'1'" /></xsl:when><xsl:otherwise><xsl:value-of select="@multiplicand"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="finalAddend">
					<xsl:choose><xsl:when test="string-length(normalize-space(@finalAddend)) = 0"><xsl:value-of select="'0'" /></xsl:when><xsl:otherwise><xsl:value-of select="@finalAddend"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="initialAddend">
					<xsl:choose><xsl:when test="string-length(normalize-space(@initialAddend)) = 0"><xsl:value-of select="'0'" /></xsl:when><xsl:otherwise><xsl:value-of select="@initialAddend"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:variable name="exact">
					<xsl:choose><xsl:when test="string-length(normalize-space(@exact)) = 0"><xsl:value-of select="'false'" /></xsl:when><xsl:otherwise><xsl:value-of select="@exact"/></xsl:otherwise></xsl:choose>
				</xsl:variable>
				<xsl:if test="not(exists($current-conversions intersect $initial-unit-id))">
              <unitsml:Float64ConversionFrom 
                initialUnit="#{$initial-unit-id}" 
                exact="{$exact}"
                multiplicand="{$divisor}"
                divisor="{$multiplicand}"
                initialAddend="{0-$finalAddend}"
                finalAddend="{0-$initialAddend}"/>
				</xsl:if>
            </xsl:for-each>
          </xsl:for-each>
        </unitsml:Conversions>
      </unitsml:Unit>
    </xsl:for-each>
  </xsl:variable>

  <xsl:template match="/">
    <!-- 
	<TARGET><xsl:copy-of select="$targetUnitSystem" /></TARGET> -->
	<!--
	<UNITINFO><xsl:copy-of select="$unitInfo" /></UNITINFO>
	-->
	<!--
	<USCDLFILE val="{$USCDFile}" />
	-->
	<!--
	<USCD><xsl:copy-of select="$USCD" /></USCD>
	-->
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="nvc:NVCs">
    <nvc:NVCs>
      <xsl:copy-of select="namespace::*" />
      <xsl:copy-of select="attribute()" />
      <xsl:apply-templates />
    </nvc:NVCs>
  </xsl:template>

  <xsl:template match="nvc:NVCs/text()">
    <xsl:if test="string-length(normalize-space(.)) = 0" >
      <xsl:copy-of select="." />
    </xsl:if>
  </xsl:template>

  <xsl:template match="nvc:values">
    <nvc:values>
      <xsl:apply-templates />
    </nvc:values>
  </xsl:template>

  <xsl:template match="nvc:values/text()">
    <xsl:if test="string-length(normalize-space(.)) = 0" >
      <xsl:copy-of select="." />
    </xsl:if>
  </xsl:template>

  <xsl:template match="nvc:nvc">
    <xsl:choose>
      <xsl:when test="count($unitInfo//unitsml:Unit/unitsml:UnitSystem[@name=$targetUnitSystem]/..//unitsml:Float64ConversionFrom[
        substring-after(@initialUnit, '#')=(current()/@unitIDREF)]) > 0">
        <!-- <CURRENTSYSTEM ref="{current()/@unitIDREF}"><xsl:copy-of select="id(current()/@unitIDREF)" /></CURRENTSYSTEM> -->
        <xsl:call-template name="multiple-direct-conversion">
          <xsl:with-param name="value" select="normalize-space(./text())" />
          <xsl:with-param name="currentSystem" select="id(current()/@unitIDREF)/unitsml:UnitSystem/@name" />
        </xsl:call-template>
      </xsl:when>
      <!-- else there's just no conversion available. Just copy the thing. -->
      <xsl:otherwise>
        <xsl:copy-of select="." />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="direct-conversion">
    <xsl:param name="conversion"/>
    <xsl:param name="value" />
    <xsl:choose>
      <xsl:when test="not(boolean($value))">
        <!-- do nothing. There's *nothing* left inside of $value. -->
      </xsl:when>
      <xsl:when test="not(contains($value, ' '))">
        <xsl:value-of select="number($conversion//@finalAddend) + 
          ( ( number($conversion//@multiplicand) div number($conversion//@divisor) ) * 
          ( number($value) + number($conversion//@initialAddend) ) )"/>
        <!-- we're done here, recursion ended. We only had/have a single value. -->
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="number($conversion//@finalAddend) + 
          ( ( number($conversion//@multiplicand) div number($conversion//@divisor) ) * 
          ( number(substring-before($value, ' ')) + number($conversion//@initialAddend) ) )"/>
        <xsl:text> </xsl:text>
        <!-- yay! recursion.. -->
        <xsl:call-template name="direct-conversion">
          <xsl:with-param name="value"><xsl:value-of select="substring-after($value, ' ')"/></xsl:with-param>
          <xsl:with-param name="conversion"><xsl:copy-of select='$conversion'/></xsl:with-param>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="dcr-compute-and-decide">
    <xsl:param name="value" />
    <xsl:param name="rangeInfo" />
    <xsl:param name="strategy" />
    <xsl:param name="currentConversion" />
    <xsl:param name="bestValue" />
    <xsl:param name="bestUnit" />
    <xsl:param name="strategicValue" />
    <xsl:param name="strategicUnit" />
    <xsl:param name="sourceUnit" />

    <xsl:variable name="conversion">
      <xsl:copy-of select="($unitInfo//unitsml:UnitSystem[@name=$targetUnitSystem]/
        ..//unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)])[$currentConversion]"/>
    </xsl:variable>
    <xsl:variable name="targetUnit">
      <xsl:copy-of select="($unitInfo//unitsml:UnitSystem[@name=$targetUnitSystem]/
        ..[.//unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)]])[$currentConversion]"/>
    </xsl:variable>
    <xsl:variable name="curMin">
      <xsl:choose>
        <xsl:when test="$sourceUnit='' and boolean($rangeInfo//range[@target=$targetUnit//@xml:id]/@min)">
          <xsl:value-of select="($rangeInfo//range[@target=$targetUnit//@xml:id]/@min)" />
        </xsl:when>
        <xsl:when test="boolean($rangeInfo//source-range[@source=$sourceUnit]/@min)">
          <xsl:value-of select="($rangeInfo//source-range[@source=$sourceUnit]/@min)" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="curMax">
      <xsl:choose>
        <xsl:when test="$sourceUnit='' and boolean($rangeInfo//range[@target=$targetUnit//@xml:id]/@max)">
          <xsl:value-of select="($rangeInfo//range[@target=$targetUnit//@xml:id]/@max)" />
        </xsl:when>
        <xsl:when test="boolean($rangeInfo//source-range[@source=$sourceUnit]/@max)">
          <xsl:value-of select="($rangeInfo//source-range[@source=$sourceUnit]/@max)" />
        </xsl:when>
        <xsl:otherwise> 
          <xsl:value-of select="'infinity'" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="curExact">
      <xsl:choose>
        <xsl:when test="$sourceUnit='' and boolean($rangeInfo//range[@target=$targetUnit//@xml:id]/@exactOnly)">
          <xsl:value-of select="($rangeInfo//range[@target=$targetUnit//@xml:id]/@exactOnly)" />
        </xsl:when>
        <xsl:when test="boolean($rangeInfo//source-range[@source=$sourceUnit]/@exactOnly)">
          <xsl:value-of select="($rangeInfo//source-range[@source=$sourceUnit]/@exactOnly)" />
        </xsl:when>
        <xsl:otherwise> 
          <xsl:value-of select="'false'" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>
      <!-- let's check if we don't have to change anything at all. -->
      <xsl:when test="$currentConversion = 0">
        <xsl:choose>
          <xsl:when test="id(current()/@unitIDREF)/unitsml:UnitSystem/@name = $targetUnitSystem">
            <xsl:variable name="result" select="number($value)" />
            <xsl:variable name="targetUnit" select="id(current()/@unitIDREF)" />
            <xsl:choose>
              <!-- outside the desired range -->
              <xsl:when test="(string($curMin) = 'infinity' or abs($result) &lt; $curMin) or 
                (string($curMax) != 'infinity' and abs($result) &gt;= $curMax)">
                <xsl:choose>
                  <xsl:when test="(string($strategicValue) = '') or (($result &lt; $strategicValue and $strategy = 'min') or
                    ($result &gt; $strategicValue and $strategy = 'max'))">
                    <xsl:call-template name="dcr-compute-and-decide">
                      <xsl:with-param name="value" select="$value" />
                      <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                      <xsl:with-param name="strategy" select="$strategy" />
                      <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                      <xsl:with-param name="bestValue" select="$bestValue" />
                      <xsl:with-param name="bestUnit" select="$bestUnit" />
                      <xsl:with-param name="strategicValue" select="$result" />
                      <xsl:with-param name="strategicUnit" select="$targetUnit//@xml:id" />
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:call-template name="dcr-compute-and-decide">
                      <xsl:with-param name="value" select="$value" />
                      <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                      <xsl:with-param name="strategy" select="$strategy" />
                      <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                      <xsl:with-param name="bestValue" select="$bestValue" />
                      <xsl:with-param name="bestUnit" select="$bestUnit" />
                      <xsl:with-param name="strategicValue" select="$strategicValue" />
                      <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                    </xsl:call-template>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <!-- within the desired range -->
              <!-- no need to update strategicValue as bestValue will be used anyways. -->
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="string($bestValue) = '' or ($result &lt; $bestValue and $strategy = 'min') or
                    ($result &gt; $bestValue and $strategy = 'max')">
                    <xsl:call-template name="dcr-compute-and-decide">
                      <xsl:with-param name="value" select="$value" />
                      <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                      <xsl:with-param name="strategy" select="$strategy" />
                      <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                      <xsl:with-param name="bestValue" select="$result" />
                      <xsl:with-param name="bestUnit" select="$targetUnit//@xml:id" />
                      <xsl:with-param name="strategicValue" select="$strategicValue" />
                      <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:call-template name="dcr-compute-and-decide">
                      <xsl:with-param name="value" select="$value" />
                      <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                      <xsl:with-param name="strategy" select="$strategy" />
                      <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                      <xsl:with-param name="bestValue" select="$bestValue" />
                      <xsl:with-param name="bestUnit" select="$bestUnit" />
                      <xsl:with-param name="strategicValue" select="$strategicValue" />
                      <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                    </xsl:call-template>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="dcr-compute-and-decide">
              <xsl:with-param name="value" select="$value" />
              <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
              <xsl:with-param name="strategy" select="$strategy" />
              <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
              <xsl:with-param name="bestValue" select="$bestValue" />
              <xsl:with-param name="bestUnit" select="$bestUnit" />
              <xsl:with-param name="strategicValue" select="$strategicValue" />
              <xsl:with-param name="strategicUnit" select="$strategicUnit" />
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="$currentConversion > count($unitInfo//unitsml:UnitSystem[@name=$targetUnitSystem]/
        ..//unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)])" >
        <xsl:choose>
          <xsl:when test="string($bestValue) = '' and string($strategicValue) != ''">
            <nvc:nvc>
              <xsl:copy-of select="attribute()" />
              <xsl:attribute name="unitIDREF"><xsl:value-of select="$strategicUnit" /></xsl:attribute>
              <xsl:value-of select="$strategicValue" />
            </nvc:nvc><xsl:text>&#10;</xsl:text>
          </xsl:when>
          <xsl:when test="string($bestValue) = '' and string($strategicValue) = ''">
            <xsl:message>Could not find a<xsl:if test="$curExact = 'true'">n exact</xsl:if> conversion! Copying node instead.</xsl:message>
            <xsl:copy-of select="current()"/>
          </xsl:when>
          <xsl:otherwise>
            <nvc:nvc>
              <xsl:copy-of select="attribute()" />
              <xsl:attribute name="unitIDREF"><xsl:value-of select="$bestUnit" /></xsl:attribute>
              <xsl:value-of select="$bestValue" />
            </nvc:nvc><xsl:text>&#10;</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="result" select="number($conversion//@finalAddend) + 
          ( ( number($conversion//@multiplicand) div number($conversion//@divisor) ) * 
          ( number($value) + number($conversion//@initialAddend) ) )"/>
        <xsl:choose>
          <!-- we cannot take this result. It's coming from an inexact conversion. -->
          <xsl:when test="$curExact = 'true' and $conversion//@exact != 'true'">
            <xsl:call-template name="dcr-compute-and-decide">
              <xsl:with-param name="value" select="$value" />
              <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
              <xsl:with-param name="strategy" select="$strategy" />
              <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
              <xsl:with-param name="bestValue" select="$bestValue" />
              <xsl:with-param name="bestUnit" select="$bestUnit" />
              <xsl:with-param name="strategicValue" select="$strategicValue" />
              <xsl:with-param name="strategicUnit" select="$strategicUnit" />
            </xsl:call-template>
          </xsl:when>
          <!-- outside the desired range -->
          <xsl:when test="
            $curMin = 'infinity' or abs($result) &lt; $curMin or 
            (string($curMax) != 'infinity' and abs($result) &gt;= $curMax)">
            <xsl:choose>
              <xsl:when test="(string($strategicValue) = '') or (($result &lt; $strategicValue and $strategy = 'min') or
                ($result &gt; $strategicValue and $strategy = 'max'))">
                <xsl:call-template name="dcr-compute-and-decide">
                  <xsl:with-param name="value" select="$value" />
                  <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                  <xsl:with-param name="strategy" select="$strategy" />
                  <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                  <xsl:with-param name="bestValue" select="$bestValue" />
                  <xsl:with-param name="bestUnit" select="$bestUnit" />
                  <xsl:with-param name="strategicValue" select="$result" />
                  <xsl:with-param name="strategicUnit" select="$targetUnit//@xml:id" />
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="dcr-compute-and-decide">
                  <xsl:with-param name="value" select="$value" />
                  <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                  <xsl:with-param name="strategy" select="$strategy" />
                  <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                  <xsl:with-param name="bestValue" select="$bestValue" />
                  <xsl:with-param name="bestUnit" select="$bestUnit" />
                  <xsl:with-param name="strategicValue" select="$strategicValue" />
                  <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <!-- within the desired range -->
          <!-- no need to update strategicValue as bestValue will be used anyways. -->
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="string($bestValue) = '' or ($result &lt; $bestValue and $strategy = 'min') or
                ($result &gt; $bestValue and $strategy = 'max')">
                <xsl:call-template name="dcr-compute-and-decide">
                  <xsl:with-param name="value" select="$value" />
                  <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                  <xsl:with-param name="strategy" select="$strategy" />
                  <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                  <xsl:with-param name="bestValue" select="$result" />
                  <xsl:with-param name="bestUnit" select="$targetUnit//@xml:id" />
                  <xsl:with-param name="strategicValue" select="$strategicValue" />
                  <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="dcr-compute-and-decide">
                  <xsl:with-param name="value" select="$value" />
                  <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
                  <xsl:with-param name="strategy" select="$strategy" />
                  <xsl:with-param name="currentConversion" select="$currentConversion + 1" />
                  <xsl:with-param name="bestValue" select="$bestValue" />
                  <xsl:with-param name="bestUnit" select="$bestUnit" />
                  <xsl:with-param name="strategicValue" select="$strategicValue" />
                  <xsl:with-param name="strategicUnit" select="$strategicUnit" />
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="direct-conversion-ranged">
    <xsl:param name="value" />
    <xsl:param name="rangeInfo" />
    <xsl:param name="strategy" />
    <xsl:param name="sourceUnit" />

    <xsl:choose>

      <xsl:when test="not(boolean($value))">
        <!-- do nothing. There's *nothing* left inside of $value. -->
      </xsl:when>

      <xsl:when test="not(contains($value, ' '))">
        <xsl:call-template name="dcr-compute-and-decide">
          <xsl:with-param name="value" select="$value" />
          <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
          <xsl:with-param name="strategy" select="$strategy" />
          <xsl:with-param name="currentConversion" select="0" />
          <xsl:with-param name="sourceUnit" select="$sourceUnit" />
        </xsl:call-template>
        <!-- we're done here, recursion ended. We only had/have a single value. -->
      </xsl:when>

      <xsl:otherwise>
        <xsl:call-template name="dcr-compute-and-decide">
          <xsl:with-param name="value" select="substring-before($value, ' ')" />
          <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
          <xsl:with-param name="strategy" select="$strategy" />
          <xsl:with-param name="currentConversion" select="0" />
          <xsl:with-param name="sourceUnit" select="$sourceUnit" />
        </xsl:call-template>
        <xsl:text> </xsl:text>
        <!-- yay! recursion.. -->
        <xsl:call-template name="direct-conversion-ranged">
          <xsl:with-param name="value" select="substring-after($value, ' ')"/>
          <xsl:with-param name="rangeInfo"><xsl:copy-of select="$rangeInfo" /></xsl:with-param>
          <xsl:with-param name="strategy" select="$strategy" />
          <xsl:with-param name="sourceUnit" select="$sourceUnit" />
        </xsl:call-template>
      </xsl:otherwise>

    </xsl:choose>
  </xsl:template>

  <xsl:template name="multiple-direct-conversion">
    <xsl:param name="value" />
    <xsl:param name="currentSystem" />
<!--
    <REMINDER1 value="{$value}" currentSystem="{$currentSystem}" targetSystem="{$targetUnitSystem}" /> 
	<REMINDER2><xsl:copy-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                @source='*' or @source=current()/@unitIDREF]/@exactOnly = 'true' and 
                $unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                        @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]//
                        unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)]/@exact = 'true')" /></REMINDER2>
	<REMINDER3><xsl:copy-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                 @source='*' or @source=current()/@unitIDREF]/@exactOnly = 'false' and 
                 (boolean($unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                        @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]//
                        unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)])))" /></REMINDER3>
	<REMINDER4><xsl:copy-of select="$USCD//uscd:conversion" /></REMINDER4>
	<REMINDER5><xsl:copy-of select="$USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]" /></REMINDER5>
	<REMINDER6><xsl:copy-of select="$USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed" /></REMINDER6>
	<REMINDER7><xsl:copy-of select="$USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
					@source='*' or @source=current()/@unitIDREF
				]" /></REMINDER7>
	<REMINDER8><xsl:copy-of select="$USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
					@source='*' or @source=current()/@unitIDREF]/@exactOnly = 'true'" /></REMINDER8>
	<REMINDER9><xsl:copy-of select="$unitInfo" /></REMINDER9>
	<REMINDER10><xsl:copy-of select="$unitInfo//unitsml:Unit" /></REMINDER10>
-->
<!--
	<REMINDER11><xsl:copy-of select="$unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                        @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]" /></REMINDER11>
-->
    <xsl:choose>
      <xsl:when test="boolean($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem])">
        <xsl:choose>
          <!-- when there's a fixed[@source="bla"] we have an explicit wish for some unit(s). Thus we
             can just follow the wish -->
          <xsl:when test="boolean($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
            @source='*' or @source=current()/@unitIDREF])">
            <xsl:choose>
              <xsl:when test="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                @source='*' or @source=current()/@unitIDREF]/@exactOnly = 'true' and 
                $unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                        @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]//
                        unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)]/@exact = 'true') or
                 ($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                 @source='*' or @source=current()/@unitIDREF]/@exactOnly = 'false' and 
                 (boolean($unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                        @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]//
                        unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)])))" >
                <nvc:nvc>
                  <xsl:copy-of select="attribute()" />
                  <xsl:attribute name="unitIDREF" 
                    select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                    @source='*' or @source=current()/@unitIDREF])/@target"
                    />
                  <xsl:choose>
                    <xsl:when test="current()/@unitIDREF != ($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/
                      uscd:fixed[
                      @source='*' or @source=current()/@unitIDREF])/@target">
                      <xsl:call-template name="direct-conversion">
                        <xsl:with-param name="value" select="$value" />
                        <xsl:with-param name="conversion">
                          <xsl:copy-of select="$unitInfo//unitsml:Unit[@xml:id=$USCD//uscd:conversion[
                            @from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF]/@target]//
                            unitsml:Float64ConversionFrom[substring-after(@initialUnit, '#')=(current()/@unitIDREF)]" />
                        </xsl:with-param>
                      </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:copy-of select="current()/text()" />
                    </xsl:otherwise>
                  </xsl:choose>
                </nvc:nvc>
              </xsl:when>
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="$USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[
                  @source='*' or @source=current()/@unitIDREF]/@exactOnly = 'true'">
                    <xsl:message>
                      Cannot find an exact conversion from "<xsl:value-of select="current()/@unitIDREF" />" to "<xsl:value-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF])/@target" />"! Copying node unchanged...
                    </xsl:message>
                    <complaint>
                      Cannot find an exact conversion from "<xsl:value-of select="current()/@unitIDREF" />" to "<xsl:value-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF])/@target" />"! Copying node unchanged...
                    </complaint>
					
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:message>
                      Cannot find a conversion from "<xsl:value-of select="current()/@unitIDREF" />" to "<xsl:value-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF])/@target" />"! Copying node unchanged...
                    </xsl:message>
                    <complaint2>
                      Cannot find a conversion from "<xsl:value-of select="current()/@unitIDREF" />" to "<xsl:value-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:fixed[@source='*' or @source=current()/@unitIDREF])/@target" />"! Copying node unchanged...
                    </complaint2>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:copy-of select="current()" />
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <!-- We're having a range description -->
          <!-- need to abide fixed[@source=''] entries ! -->
          <!-- need check for exactOnly and do the right thing (see fixed, above) -->
          <xsl:when test="boolean($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:range)">
            <xsl:call-template name="direct-conversion-ranged">
              <xsl:with-param name="value" select="$value" />
              <xsl:with-param name="rangeInfo">
                <xsl:copy-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:range)" />
              </xsl:with-param>
              <xsl:with-param name="strategy" select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/@strategy)" />
            </xsl:call-template>
          </xsl:when>
          <!-- we're having a source range description -->
          <!-- need to abide fixed[@source=''] entries ! -->
          <!-- need check for exactOnly and do the right thing (see fixed, above) -->
          <xsl:when test="boolean($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:source-range)">
            <xsl:call-template name="direct-conversion-ranged">
              <xsl:with-param name="value" select="$value" />
              <xsl:with-param name="rangeInfo">
                <xsl:copy-of select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/uscd:source-range)" />
              </xsl:with-param>
              <xsl:with-param name="strategy" select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/@strategy)" />
              <xsl:with-param name="sourceUnit" select="current()/@unitIDREF" />
            </xsl:call-template>
          </xsl:when>
          <!-- we don't have any description at all. Use the strategy. -->
          <!-- Obey fixed/@source = '' -->
          <xsl:otherwise>
            <xsl:call-template name="direct-conversion-ranged">
              <xsl:with-param name="value" select="$value" />
              <xsl:with-param name="strategy" select="($USCD//uscd:conversion[@from=$currentSystem and @to=$targetUnitSystem]/@strategy)" />
              <xsl:with-param name="sourceUnit" select="current()/@unitIDREF" />
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <!--<ORIGINAL>--><xsl:copy-of select="current()"/><!--</ORIGINAL>-->
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="comment()|processing-instruction()">
    <xsl:copy-of select="."/>
  </xsl:template>

  <xsl:template match="*|text()">
    <xsl:copy-of select="."/>
  </xsl:template>
</xsl:stylesheet>
